//---------------------------------------------------------------------------

#ifndef markovH
#define markovH

#include "myutils.h"

//    N   + 
//     ,    
//   N  
//  ,     N ,
//   ,   

extern int N_PREFIX_WORD;      //-   
#define MAX_OUTPUT_WORD 1000   //   
#define HASH_SIZE (1<<17)

typedef struct TWord TWord;
typedef TWord** TWordPtrArray;
struct TWord{
  char *word;
  unsigned key;
  int len;
};
TWord *TWordNew( char s[] );


typedef struct TPrefix TPrefix;
typedef struct TSuffix TSuffix;
struct TPrefix{
  TWord **pref_array; //array[0..N_PREFIX_WORD-1] of *TWord;
  TSuffix *suffix_list; // list
  TPrefix *next;    //    -
  TPrefix *nextMainList; //    
};
TPrefix* TPrefixNew(TWord **pref_array,TSuffix *suffix_list,TPrefix *next);

struct TSuffix{
  TWord **suf;      //
  TSuffix* next;    //      
  int cnt; //       
};
TSuffix* TSuffixNew(TWord **suf,TSuffix* next,int cnt);








char *GetWord( FILE *f );            /*    */
TWordPtrArray FileToWords(                  /* filr to array_ptr_of_word + 0 */
                    char fname[],
                    char* (*GetWord)( FILE *f ) //  
                  );




typedef struct THashPrefix THashPrefix;
struct THashPrefix{
  TPrefix* hash[HASH_SIZE-1];
  TPrefix *list;
  int cnt;
};
THashPrefix* THashPrefixNew   (void)      { return (THashPrefix*)calloc(sizeof(THashPrefix),1); }
TPrefix*     THashPrefixLook  ( THashPrefix* h, TPrefix* node );
TPrefix*     THashPrefixInsert( THashPrefix* h, TPrefix* node );


int GenMarkovText( char fname_source[],int max_words_output );

//---------------------------------------------------------------------------
#endif
